import React from 'react';
import { onBlurFn } from '../onBlurFn';
import { ApolloNumber } from '../number';
import { isNumber } from '../../../../utils/utils';

export const ApolloPercentage = (props: any) => {
    const inputOnBlurFn = () => {
        if (typeof onBlurFn === 'function') {
            onBlurFn(props);
        }
    };
    return (
        <ApolloNumber
            {...props}
            formatter={(value) => {
                if (isNumber(value)) {
                    return `${value}%`;
                }
                return value;
            }}
            parser={(value) => {
                if (value) {
                    return value.replace('%', '');
                }
                return '';
            }}
            onBlur={inputOnBlurFn}
        />
    );
};
