import React from 'react';
import { Rate } from 'antd';
import { antiAssign } from '../../../../utils/utils';
import s from './index.less';
import { ApolloRateProps } from '../editInterface';
import { onBlurFn } from '../onBlurFn';

export const ApolloRate = (props: ApolloRateProps) => {
    const { onChange } = props;
    const selfProps = antiAssign(props, [
        'columnConfig',
        'onChange',
        'tableId',
        'cellRenderProps',
        'maxPopHeight',
        'getCalendarContainer',
        'getCalendarContainer',
        'origin',
    ]);

    const changeValue = (value) => {
        if (typeof onChange === 'function') {
            if (typeof onBlurFn === 'function') {
                onBlurFn({ ...props, value });
            }
            onChange(value);
        }
    };
    return <Rate className={s.rate} {...selfProps} onChange={changeValue} />;
};
